hpp-constraints: hpp::constraints::DistanceBetweenPointsInBodies Class Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::constraints::DistanceBetweenPointsInBodies Class Reference

`#include <hpp/constraints/distance-between-points-in-bodies.hh>`

Inheritance diagram for hpp::constraints::DistanceBetweenPointsInBodies:
[legend]
Collaboration diagram for hpp::constraints::DistanceBetweenPointsInBodies:
[legend]

## Public Member Functions
virtual | ~DistanceBetweenPointsInBodies ()
Public Member Functions inherited from hpp::constraints::DifferentiableFunction
virtual | ~DifferentiableFunction ()
LiegroupElement | operator() (vectorIn_t argument) const
void | value (LiegroupElementRef result, vectorIn_t argument) const
void | jacobian (matrixOut_t jacobian, vectorIn_t argument) const
const ArrayXb & | activeParameters () const
const ArrayXb & | activeDerivativeParameters () const
size_type | inputSize () const
| Get dimension of input vector.
size_type | inputDerivativeSize () const
LiegroupSpacePtr_t | outputSpace () const
| Get output space.
size_type | outputSize () const
| Get dimension of output vector.
size_type | outputDerivativeSize () const
| Get dimension of output derivative vector.
const std::string & | name () const
| Get function name.
virtual std::ostream & | print (std::ostream &o) const
| Display object in a stream.
std::string | context () const
void | context (const std::string &c)
void | finiteDifferenceForward (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
void | finiteDifferenceCentral (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
bool | operator== (DifferentiableFunction const &other) const
bool | operator!= (DifferentiableFunction const &b) const
virtual std::pair< JointConstPtr_t, JointConstPtr_t > | dependsOnRelPoseBetween (DeviceConstPtr_t) const

## Static Public Member Functions
static EIGEN_MAKE_ALIGNED_OPERATOR_NEW DistanceBetweenPointsInBodiesPtr_t | create (const std::string &name, const DevicePtr_t &robot, const JointPtr_t &joint1, const JointPtr_t &joint2, const vector3_t &point1, const vector3_t &point2)
static DistanceBetweenPointsInBodiesPtr_t | create (const std::string &name, const DevicePtr_t &robot, const JointPtr_t &joint1, const vector3_t &point1, const vector3_t &point2)
Static Public Member Functions inherited from hpp::constraints::DifferentiableFunction
static DifferentiableFunctionPtr_t | extract (DifferentiableFunctionPtr_t original, interval_t interval)

## Protected Member Functions
| DistanceBetweenPointsInBodies (const std::string &name, const DevicePtr_t &robot, const JointPtr_t &joint1, const JointPtr_t &joint2, const vector3_t &point1, const vector3_t &point2)
| DistanceBetweenPointsInBodies (const std::string &name, const DevicePtr_t &robot, const JointPtr_t &joint1, const vector3_t &point1, const vector3_t &point2)
virtual void | impl_compute (LiegroupElementRef result, ConfigurationIn_t argument) const
virtual void | impl_jacobian (matrixOut_t jacobian, ConfigurationIn_t arg) const
bool | isEqual (const DifferentiableFunction &other) const
Protected Member Functions inherited from hpp::constraints::DifferentiableFunction
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, size_type sizeOutput, std::string name=std::string())
| Concrete class constructor should call this constructor.
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, const LiegroupSpacePtr_t &outputSpace, std::string name=std::string())
| Concrete class constructor should call this constructor.
virtual void | impl_compute (LiegroupElementRef result, vectorIn_t argument) const =0
| User implementation of function evaluation.
virtual void | impl_jacobian (matrixOut_t jacobian, vectorIn_t arg) const =0
| DifferentiableFunction ()

## Additional Inherited Members
Protected Attributes inherited from hpp::constraints::DifferentiableFunction
size_type | inputSize_
| Dimension of input vector.
size_type | inputDerivativeSize_
| Dimension of input derivative.
LiegroupSpacePtr_t | outputSpace_
| Dimension of output vector.
ArrayXb | activeParameters_
ArrayXb | activeDerivativeParameters_

## Detailed Description

Distance between two sets of objects

This function maps to a configuration of a robot, the distance

- either between two points in two joints
- or between a point in a joint and a point in the environment

The type of distance above is determined by the method "create" called.

## Constructor & Destructor Documentation

## ◆ ~DistanceBetweenPointsInBodies()

virtual hpp::constraints::DistanceBetweenPointsInBodies::~DistanceBetweenPointsInBodies | ( |  | ) |
| inline virtual

## ◆ DistanceBetweenPointsInBodies() [1/2]

hpp::constraints::DistanceBetweenPointsInBodies::DistanceBetweenPointsInBodies | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint1,
|  | const JointPtr_t & | joint2,
|  | const vector3_t & | point1,
|  | const vector3_t & | point2 )
| protected

Protected constructor

Parameters

  name | name of the constraint,
  robot | robot that own the bodies,
  joint1 | joint that holds the first body,
  joint2 | joint that holds the second body.

## ◆ DistanceBetweenPointsInBodies() [2/2]

hpp::constraints::DistanceBetweenPointsInBodies::DistanceBetweenPointsInBodies | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint1,
|  | const vector3_t & | point1,
|  | const vector3_t & | point2 )
| protected

Protected constructor

Parameters

  name | name of the constraint,
  robot | robot that own the bodies,
  joint1 | joint that holds the first body,

## Member Function Documentation

## ◆ create() [1/2]

static EIGEN_MAKE_ALIGNED_OPERATOR_NEW DistanceBetweenPointsInBodiesPtr_t hpp::constraints::DistanceBetweenPointsInBodies::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint1,
|  | const JointPtr_t & | joint2,
|  | const vector3_t & | point1,
|  | const vector3_t & | point2 )
| static

Create instance and return shared pointer

Parameters

  name | name of the constraint,
  robot | robot that own the bodies,
  joint1 | joint that holds the first point,
  joint2 | joint that holds the second point,
  point1 | point in frame of joint 1,
  point2 | point in frame of joint 2.

## ◆ create() [2/2]

static DistanceBetweenPointsInBodiesPtr_t hpp::constraints::DistanceBetweenPointsInBodies::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint1,
|  | const vector3_t & | point1,
|  | const vector3_t & | point2 )
| static

Create instance and return shared pointer

Parameters

  name | name of the constraint,
  robot | robot that own the bodies,
  joint1 | joint that holds the first point,
  point1 | point in frame of joint 1,
  point2 | point in frame of joint 2.

## ◆ impl_compute()

virtual void hpp::constraints::DistanceBetweenPointsInBodies::impl_compute | ( | LiegroupElementRef | result,
|  | ConfigurationIn_t | argument ) const
| protected virtual

## ◆ impl_jacobian()

virtual void hpp::constraints::DistanceBetweenPointsInBodies::impl_jacobian | ( | matrixOut_t | jacobian,
|  | ConfigurationIn_t | arg ) const
| protected virtual

## ◆ isEqual()

bool hpp::constraints::DistanceBetweenPointsInBodies::isEqual | ( | const DifferentiableFunction & | other | ) | const
| inline protected virtual

Reimplemented from hpp::constraints::DifferentiableFunction.

The documentation for this class was generated from the following file:

- include/hpp/constraints/distance-between-points-in-bodies.hh